//  IoT電子工作キット sLab-Remo2
//  2-1-6.赤外線リモコン送信

const byte IR_S_PIN = 32;       // ①GPIO32で送信制御
// ②送信データを設定
unsigned short irData[] = { 347,172,40, ... ,41,175 };  // ### 【データ書換が必要】 ###

// ③起動時の初期設定
void setup() {
  Serial.begin(115200);
  Serial.println();
  pinMode(IR_S_PIN, OUTPUT);
}

// ④赤外線リモコン信号を10秒間隔で繰り返し送信する
void loop() {
  irSend ();                  // ⑤赤外線送信する関数を実行
  Serial.println("SndOK");
  delay(10000);               // ⑥10秒間Wait
}

// ⑦赤外線送信処理
void irSend () {
  // ⑧ローカル変数定義
  unsigned short irCount = 0; // HIGH,LOWの信号数
  unsigned long l_now = 0;    // 送信開始時間を保持
  unsigned long sndt = 0;     // 送信開始からの経過時間
  // ⑨HIGH,LOWの信号数を計算
  irCount = sizeof(irData) / sizeof(irData[0]);
  // ⑩送信開始時間を取得
  l_now = micros();
  // ⑪0,1の信号回数分をFor文でループ
  for (int i = 0; i < irCount; i++) {
    // ⑫送信開始からの信号終了時間を計算
    sndt += irData[i];
    do {
      // ⑬iが偶数なら赤外線ON、奇数ならOFFのまま
      // ⑭キャリア周波数38kHz(約26μSec周期の半分)でON時間で送信
      digitalWrite(IR_S_PIN, !(i&1));
      microWait(13);
      // ⑮キャリア周波数38kHz(約26μSec周期の半分)でOFF時間で送信
      digitalWrite(IR_S_PIN, 0);
      microWait(13);
    // ⑯送信開始からの信号終了時間が超えるまでループ
    } while (long(l_now + (sndt * 10) - micros()) > 0);
  }
}

// ⑰マイクロ秒単位で待つ
void microWait(signed long waitTime) {
  unsigned long waitStartMicros = micros();
  // ⑱指定されたマイクロ秒が経過するまでWhileでループ処理（待つ）
  while (micros() - waitStartMicros < waitTime) {};
}
