//  IoT電子工作キット sLab-Remo2
//  3-2.Webサーバ機能

// ①ライブラリを読み込み
#include <WiFi.h>
#include <ESPAsyncWebServer.h>

// ②ピン配置
const byte LED_PIN = 12;  // LED緑
bool ledFlag = true;      // LED制御フラグ

// ③Wi-Fi設定
const char *ssid      = "##### SSID #####";
const char *password  = "### PASSWORD ###";
IPAddress ip(192, 168, 1, 123);     // IPアドレス（本機が利用するIP）
IPAddress gateway(192, 168, 1, 1);  // デフォルトゲートウェイ
IPAddress subnet(255, 255, 255, 0); // サブネットマスク

// ④WebServerを定義（ポート80番を使用）
AsyncWebServer webServer ( 80 );

void setup(void) {
  // ⑤Serial設定
  Serial.begin(115200);
  Serial.println ( );
  // ⑥LED設定
  pinMode ( LED_PIN, OUTPUT );
  // ⑦無線Wi-Fi接続
  WiFi.config( ip, gateway, subnet );
  WiFi.begin ( ssid, password );

  // ⑧Wi-Fi接続処理（接続するまで無限ループ）
  while ( WiFi.status() != WL_CONNECTED ) {
    // ⑨LEDを１秒毎に点滅する
    ledFlag = !ledFlag;
    digitalWrite(LED_PIN, ledFlag);
    // ⑩１秒間Wait
    delay ( 1000 );
    Serial.print ( "." );
  }
  // ⑪Wi-Fi接続できたのでシリアルモニターにIPアドレス表示
  Serial.print ( "Wi-Fi Connected! IP address: " );
  Serial.println ( WiFi.localIP() );
  // ⑫LED点灯（Wi-Fi接続状態）
  digitalWrite ( LED_PIN, true );

  // ⑬WebServerの受信処理"/"を設定
  webServer.on("/", HTTP_GET, [](AsyncWebServerRequest *request){
    // ⑭HTMLを返答する
    request->send ( 200, "text/html", "Hello World!" );
    Serial.println ( "send html" );
  });
  // ⑮WebServer起動処理
  webServer.begin();
  Serial.println ( "Web server started" );
}

void loop(void){
}
